## pd-vstplugin 0.6.1

=== sc/CMakeLists.txt ===
message(STATUS "---\n*** VSTPlugin ***")

# Installation path
# install directory:
if (WIN32)
    set(SC_INSTALLDIR "${LOCALAPPDATA}/SuperCollider/Extensions/" CACHE PATH "Installation directoy")
elseif(APPLE)
    set(SC_INSTALLDIR "~/Library/Application Support/SuperCollider/Extensions/" CACHE PATH "Installation directoy")
else()
    set(SC_INSTALLDIR "~/.local/share/SuperCollider/Extensions/" CACHE PATH "Installation directoy")
endif()
if (NOT SC_INSTALLDIR)
    # HACK: force relative path!
    set(SC_INSTALLDIR ".")
endif()
message(STATUS "SC_INSTALLDIR: ${SC_INSTALLDIR}")

if (BUILD_WINE)
    # install wine hosts
    # NB: we cannot install it as a target because CMake would use the wrong
    # output name, so we need to use PROGRAMS with the full absolute file path.
    # NB: generator expressions are only supported for RENAME with CMake 3.20+,
    # so we use the OUTPUT_NAME property instead.
    get_target_property(hostname host OUTPUT_NAME)
    install(PROGRAMS "$<TARGET_FILE_DIR:host>/${hostname}.exe.so"
        RENAME "${hostname}"
        DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")

    if (BUILD_HOST32)
        get_target_property(host32name host32 OUTPUT_NAME)
        install(PROGRAMS "$<TARGET_FILE_DIR:host32>/${host32name}.exe.so"
            RENAME ${host32name}
            DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    endif()

    # don't actually build UGens
    return()
endif()

# SuperCollider API:
set(SC_INCLUDEDIR "" CACHE PATH "Path to SuperCollider respository")
message(STATUS "SC_INCLUDEDIR: ${SC_INCLUDEDIR}")

option(SUPERNOVA "Build plugins for supernova" OFF)
message(STATUS "SUPERNOVA: ${SUPERNOVA}")

# common properties
add_library(sc_common INTERFACE)

target_sources(sc_common INTERFACE "src/VSTPlugin.h" "src/VSTPlugin.cpp")

target_include_directories(sc_common INTERFACE
    ${SC_INCLUDEDIR}/include/plugin_interface
    ${SC_INCLUDEDIR}/include/common
    ${SC_INCLUDEDIR}/plugin_interface
    ${SC_INCLUDEDIR}/common)

# plugin extension
if(APPLE OR WIN32)
    set(SUFFIX ".scx")
else()
    set(SUFFIX ${CMAKE_SHARED_MODULE_SUFFIX})
endif()

if (WIN32 AND HAVE_WINDRES)
    # resource file for sclang icon
    target_sources(sc_common INTERFACE "src/VSTPlugin.rc")
endif()

target_link_libraries(sc_common INTERFACE vst)

# the UGen
add_library(sc MODULE)
target_link_libraries(sc PRIVATE sc_common)
set_target_properties(sc PROPERTIES
    PREFIX "" # no prefix!
    OUTPUT_NAME "VSTPlugin"
    SUFFIX ${SUFFIX})

# the Supernova UGen
if (SUPERNOVA)
    add_library(sc_supernova MODULE)
    target_compile_definitions(sc_supernova PRIVATE SUPERNOVA=1)
    # for <nova-tt/spin_lock.h>
    target_include_directories(sc_supernova PRIVATE
        ${SC_INCLUDEDIR}/external_libraries/nova-tt)
    # for <boost/atomic.hpp>
    target_include_directories(sc_supernova PRIVATE
        ${SC_INCLUDEDIR}/external_libraries/boost)
    target_link_libraries(sc_supernova PRIVATE sc_common)
    set_target_properties(sc_supernova PROPERTIES
        PREFIX "" # no prefix!
        OUTPUT_NAME "VSTPlugin_supernova"
        SUFFIX ${SUFFIX})
endif()

# installation

install(TARGETS sc DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
if (MSVC)
    install(FILES $<TARGET_PDB_FILE:sc> OPTIONAL DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
endif()

if (SUPERNOVA)
    install(TARGETS sc_supernova DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    if (MSVC)
        install(FILES $<TARGET_PDB_FILE:sc_supernova> OPTIONAL DESTINATION "${SC_INSTALLDIR}/scvst/plugins")
    endif()
endif()

# installation
if (TARGET host)
    add_dependencies(sc_common host)
    install(TARGETS host DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    if (MSVC)
        install(FILES $<TARGET_PDB_FILE:host> OPTIONAL DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    endif()
endif()

if (TARGET host32)
    add_dependencies(sc_common host32)
    install(TARGETS host32 DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
endif()

if (TARGET host_amd64)
    add_dependencies(sc_common host_amd64)
    install(TARGETS host_amd64 DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
endif()

if (WIN32)
    if (HOST32_PATH)
        install(PROGRAMS "${HOST32_PATH}" RENAME "host_i386.exe"
            DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    endif()

    if (HOST_AMD64_PATH)
        install(PROGRAMS "${HOST_AMD64_PATH}" RENAME "host_amd64.exe"
            DESTINATION "${SC_INSTALLDIR}/VSTPlugin/plugins")
    endif()
endif()

install(DIRECTORY "classes" DESTINATION "${SC_INSTALLDIR}/VSTPlugin")
install(DIRECTORY "doc" DESTINATION "${SC_INSTALLDIR}/VSTPlugin")
install(DIRECTORY "HelpSource" DESTINATION "${SC_INSTALLDIR}/VSTPlugin")
install(FILES "../README.md" "../LICENSE.txt" DESTINATION "${SC_INSTALLDIR}/VSTPlugin")

=== vst/CMakeLists.txt ===
# common public properties
add_library(vst_public INTERFACE)

# common private properties
add_library(vst_common INTERFACE)

target_include_directories(vst_public INTERFACE ".")

# logging
set(LOG_LEVEL "INFO" CACHE STRING "Log level")
set_property(CACHE LOG_LEVEL PROPERTY STRINGS "SILENT;ERROR;WARNING;INFO;DEBUG;VERBOSE")
message(STATUS "Log level: ${LOG_LEVEL}")
target_compile_definitions(vst_public INTERFACE LOG_LEVEL=LOG_LEVEL_${LOG_LEVEL})

# Windows version
if (WIN32)
    # requires at least Windows 7
    set(WINVER "0x0601" CACHE STRING "Minimum supported windows version")
    if (WINVER)
        target_compile_definitions(vst_public INTERFACE _WIN32_WINNT=${WINVER})
    endif()
endif()

target_sources(vst_common INTERFACE
    "Bus.h" "CpuArch.cpp" "CpuArch.h"
    "FileUtils.cpp" "FileUtils.h"
    "HostApp.cpp" "HostApp.h"
    "Interface.h" "Lockfree.h" "Log.h"
    "MiscUtils.cpp" "MiscUtils.h" "Module.cpp"
    "PluginCommand.h" "PluginDesc.cpp" "PluginDesc.h"
    "PluginDictionary.cpp" "PluginDictionary.h"
    "PluginFactory.cpp" "PluginFactory.h"
    "Search.cpp" "Sync.cpp" "Sync.h"
    "ThreadedPlugin.cpp" "ThreadedPlugin.h")

# platform specific VST sources and defines
if (WIN32 OR BUILD_WINE)
    target_sources(vst_common INTERFACE "WindowWin32.h" "WindowWin32.cpp")
elseif (LINUX)
    target_compile_definitions(vst_common INTERFACE TARGET_API_MAC_CARBON=1)
    target_sources(vst_common INTERFACE "WindowX11.h" "WindowX11.cpp")
elseif (APPLE)
    target_compile_options(vst_common INTERFACE -fno-objc-arc)
    target_sources(vst_common INTERFACE "WindowCocoa.h" "WindowCocoa.mm")
endif()

option(PROBE_LOG "show output of probe process" OFF)
mark_as_advanced(PROBE_LOG)
if (PROBE_LOG)
    target_compile_definitions(vst_common INTERFACE PROBE_LOG=1)
endif()

option(BRIDGE_LOG "show stdout/stderr of bridge process" OFF)
mark_as_advanced(BRIDGE_LOG)
if (BRIDGE_LOG)
    target_compile_definitions(vst_common INTERFACE BRIDGE_LOG=1)
endif()

if (BUILD_WINE)
    if (LINUX)
        target_compile_definitions(vst_public INTERFACE
            VST_HOST_SYSTEM=VST_LINUX)
    endif()

    if (APPLE)
        target_compile_definitions(vst_public INTERFACE
            VST_HOST_SYSTEM=VST_MACOS)
    endif()

    option(WINE_MSVCRT "Use Wine MSVCRT.dll instead of libc" OFF)
    if (WINE_MSVCRT)
        target_compile_definitions(vst_public INTERFACE -mno-cygwin)
    endif()
endif()

# use wmain?
if (WIN32 OR BUILD_WINE)
    if (WIN32)
        set(WMAIN ON CACHE BOOL "Use wmain")
    else()
        # wmain gives me trouble on Wine
        # (undefined reference to wWinMain)
        set(WMAIN OFF CACHE BOOL "Use wmain")
    endif()
    target_compile_definitions(vst_public INTERFACE
        USE_WMAIN=$<BOOL:${WMAIN}>)
endif()

# use std::filesystem?
if (WIN32)
    # always use on Windows!
    set(STDFS ON)
else()
    if (LINUX)
        if (BUILD_WINE)
            # std::filesystem causes big trouble on Wine...
            set(STDFS OFF CACHE BOOL "Use std::filesystem" FORCE)
        else()
            set(STDFS ON CACHE BOOL "Use std::filesystem")
        endif()
    else()
        # not available on older clang version on macOS
        set(STDFS OFF CACHE BOOL "Use std::filesystem")
    endif()
endif()
target_compile_definitions(vst_common INTERFACE USE_STDFS=$<BOOL:${STDFS}>)
if (STDFS)
    # for GCC 9.1> and Clang 9.0>
    if (CMAKE_COMPILER_IS_GNUCXX
            AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.1))
        target_link_libraries(vst_common INTERFACE -lstdc++fs)
    elseif (CMAKE_COMPILER_IS_CLANG
            AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0))
        target_link_libraries(vst_common INTERFACE -lc++fs)
    endif()
endif()

# VST2 SDK
option(VST2 "Enable VST2.x plug-ins" ON)
target_compile_definitions(vst_public INTERFACE USE_VST2=$<BOOL:${VST2}>)
if (VST2)
    set(VST2DIR "${CMAKE_CURRENT_SOURCE_DIR}/VST_SDK/VST2_SDK/" CACHE PATH "path to VST2_SDK")
    message(STATUS "Build with VST2 support")
    message(STATUS "VST2DIR: ${VST2DIR}")
    target_include_directories(vst_common INTERFACE ${VST2DIR}/pluginterfaces/vst2.x)
    target_sources(vst_common INTERFACE "VST2Plugin.h" "VST2Plugin.cpp")
endif()

# VST3 SDK
option(VST3 "Enable VST3 plug-ins" ON)
target_compile_definitions(vst_public INTERFACE USE_VST3=$<BOOL:${VST3}>)
if (VST3)
    set(VST3DIR "${CMAKE_CURRENT_SOURCE_DIR}/VST_SDK/VST3_SDK/" CACHE PATH "path to VST3_SDK")
    message(STATUS "Build with VST3 support")
    message(STATUS "VST3DIR: ${VST3DIR}")
    target_include_directories(vst_common INTERFACE
        ${VST3DIR}
        ${VST3DIR}/pluginterfaces
        ${VST3DIR}/pluginterfaces/base
        ${VST3DIR}/pluginterfaces/vst
        ${VST3DIR}/pluginterfaces/gui
        # if VST2 SDK is included in VST3 SDK
        ${VST3DIR}/pluginterfaces/vst2.x)
    target_sources(vst_common INTERFACE "VST3Plugin.h" "VST3Plugin.cpp")
endif()

# bit bridging
option(BRIDGE "Enable plugin bridge" ON)
target_compile_definitions(vst_public INTERFACE USE_BRIDGE=$<BOOL:${BRIDGE}>)
if (BRIDGE)
    message(STATUS "Enable plugin bridge")

    # build host apps
    if (LINUX)
        # On Linux/Wine we can always build a 32-bit host app if the required 32-bit
        # libraries are installed, so we always show the option. If we did a compile check
        # and the libraries were not installed (yet), the option would remain hidden...
        option(BUILD_HOST32 "Build 32-bit host app" OFF)
    endif()

    if (APPLE)
        # On macOS we only show the option if we do NOT build a universal binary.
        # (A universal host app already supports bridging via the 'arch' command, see vst/HostApp.cpp)
        list(LENGTH CMAKE_OSX_ARCHITECTURES numarchs)
        if (numarchs LESS 2)
            # Only show the 32-bit Intel option if supported by the toolchain.
            if (HAS_M32_SUPPORT AND NOT (CMAKE_OSX_ARCHITECTURES STREQUAL "i386"))
                option(BUILD_HOST32 "Build 32-bit host app" OFF)
            endif()
            # Only show the 64-bit Intel option if we are building for arm64 (only).
            if ((CMAKE_OSX_ARCHITECTURES STREQUAL "arm64") OR
                    (NOT CMAKE_OSX_ARCHITECTURES AND (CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "arm64")))
                option(BUILD_HOST_AMD64 "Build 64-bit Intel host app" OFF)
            endif()
        endif()
    endif()

    if (WIN32)
        # simplify host app installation
        if (CMAKE_SIZEOF_VOID_P EQUAL 4)
            set(HOST_AMD64_PATH "" CACHE FILEPATH "(optional) absolute file path of the 64-bit host.exe")
        else()
            set(HOST32_PATH "" CACHE FILEPATH "(optional) absolute file path of the 32-bit host.exe")
        endif()
    endif()

    target_sources(vst_common INTERFACE
        "PluginBridge.h" "PluginBridge.cpp"
        "PluginClient.h" "PluginClient.cpp"
        "PluginServer.h" "PluginServer.cpp"
        "ShmInterface.h" "ShmInterface.cpp")
endif()

# Wine support on Linux
if (LINUX)
    option(WINE "Enable support for running Windows VSTs with Wine" ON)
    if (WINE)
        if (BRIDGE)
            message(STATUS "Enable Wine support")
        else()
            message(WARNING "Wine support requires BRIDGE=ON")
        endif()
    endif()
    target_compile_definitions(vst_public INTERFACE USE_WINE=$<BOOL:${WINE}>)
endif()

# static linking?
if(LINUX AND CMAKE_COMPILER_IS_GNUCXX)
    option(STATIC_LIBS "link with static libraries (libstdc++ and libgcc)" OFF)
endif()

if(MINGW)
    option(STATIC_LIBS "link with static libraries (libstdc++, libgcc and phread)" ON)
endif()

# platform specific linker flags
if (LINUX)
    if (BRIDGE)
        target_link_libraries(vst_common INTERFACE -lrt)
    endif()
    if (BUILD_WINE)
        target_link_libraries(vst_common INTERFACE -lpthread)
    else()
        target_compile_options(vst_common INTERFACE -pthread)
        target_link_libraries(vst_common INTERFACE -pthread -ldl -L/usr/X11R6/lib -lX11)
    endif()
    if(STATIC_LIBS)
        target_link_libraries(vst_common INTERFACE -static-libstdc++ -static-libgcc)
        message(STATUS "Linking statically with libstdc++ and libgcc")
    endif()
    target_compile_options(vst_common INTERFACE -fPIC)
    set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)
endif()

if (WIN32 OR BUILD_WINE)
    # for COM
    target_link_libraries(vst_common INTERFACE ole32)
endif()

if (BUILD_WINE)
    # HACK: --strip resp. install/strip only works for binaries installed as targets,
    # but we need to install the wine host(s) as programs. As a workaround, we manually
    # strip the symbols at link time - but only in Release mode.
    add_link_options($<$<CONFIG:RELEASE>:-s>)
endif()

if (MINGW)
    if (STATIC_LIBS)
        target_link_libraries(vst_common INTERFACE -static-libstdc++ -static-libgcc "-static -lpthread")
        message(STATUS "Linking statically with libstdc++, libgcc and libpthread")
    else()
        target_link_libraries(vst_common INTERFACE -lpthread)
    endif()
endif()

if (APPLE)
    target_link_libraries(vst_common INTERFACE "-framework Cocoa" -lpthread)
endif()

# static libraries
add_library(vst STATIC)
target_link_libraries(vst PUBLIC vst_public PRIVATE vst_common)

if (BUILD_HOST32)
    add_library(vst32 STATIC)
    target_link_libraries(vst32 PUBLIC vst_public PRIVATE vst_common)
    target_compile_options(vst32 PUBLIC -m32)
endif()

if (BUILD_HOST_AMD64)
    add_library(vst_amd64 STATIC)
    target_link_libraries(vst_amd64 PUBLIC vst_public PRIVATE vst_common)
    set_target_properties(vst_amd64 PROPERTIES OSX_ARCHITECTURES x86_64)
endif()

# host
add_executable(host "host.cpp") # HOST exe
if (BUILD_WINE)
    if (CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(HOSTNAME "host_pe_amd64")
    elseif (CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(HOSTNAME "host_pe_i386")
    else()
        message(FATAL_ERROR "unexpected value for CMAKE_SIZEOF_VOID_P")
    endif()
    set_target_properties(host PROPERTIES OUTPUT_NAME "${HOSTNAME}")
endif()
target_link_libraries(host vst)
if (WMAIN AND (MINGW OR BUILD_WINE))
    # -municode must be a linker flag!
    target_link_libraries(host -municode)
endif()

# 32-bit host
if (BUILD_HOST32)
    message(STATUS "Build 32-bit host program")
    # is -m32 always Intel?
    add_executable(host32 "host.cpp")
    target_compile_options(host32 PUBLIC -m32)
    target_link_options(host32 PUBLIC -m32)
    target_link_libraries(host32 vst32)
    if (WMAIN AND (MINGW OR BUILD_WINE))
        # -municode must be a linker flag!
        target_link_libraries(host32 -municode)
    endif()
    if (BUILD_WINE)
        set(HOSTNAME32 "host_pe_i386")
    else()
        set(HOSTNAME32 "host_i386")
    endif()
    set_target_properties(host32 PROPERTIES OUTPUT_NAME "${HOSTNAME32}")
endif()

# 64-bit Intel host (for Apple M1)
if (BUILD_HOST_AMD64)
    message(STATUS "Build 64-bit Intel host program")
    set(HOST_AMD64 "host_amd64")
    add_executable(host_amd64 "host.cpp")
    set_target_properties(host_amd64 PROPERTIES OSX_ARCHITECTURES "x86_64")
    target_link_libraries(host_amd64 vst_amd64)
endif()

=== debian/changelog ===
pd-vstplugin (0.6.1-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #1117666)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 11 Oct 2025 18:19:10 +0200

=== debian/control ===
Source: pd-vstplugin
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-puredata,
 cmake,
 fst-dev,
 libvst3sdk-dev,
 libx11-dev,
 supercollider-dev,
Standards-Version: 4.7.2
Homepage: https://git.iem.at/pd/vstplugin
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin

Package: pd-vstplugin
Architecture: any
Depends:
 ${misc:Depends},
 ${puredata:Depends},
 ${shlibs:Depends},
Recommends:
 ${puredata:Recommends},
Suggests:
 ${puredata:Suggests},
Provides:
 ${puredata:Provides},
Description: use VST plugins within Pure Data (Pd)
 the Pd object [vstplugin~] allows you to use VST (2 and 3) audio plugins
 within the Pure Data realtime computermusic environment.
 .
 Features:
  - supports all VST2 and VST3 plugins (audio effect, MIDI effect,
    instruments, etc.)
  - automate plugin parameters (sample accurate for VST3 plugins)
  - arbitrary number of inputs/outputs + VST3 multi-bus support
  - use either the native VST GUI or a generic editor
  - preset management: read/write standard VST preset files or set/get the
    plugin state as raw data to build your own preset management
  - MIDI input/output
  - transport and tempo support (for arpeggiators, sequencers, parameters
    with musical time units, etc.)
  - offline rendering
  - search for plugins in the standard VST directories or in user defined
    paths
  - bit-bridging and sandboxing
  - (optional) multithreaded plugin processing

Package: sc3-vstplugin
Architecture: any
Depends:
 supercollider-language,
 supercollider-server,
 ${misc:Depends},
 ${shlibs:Depends},
Description: use VST plugins within SuperCollider (SC3)
 the 'VSTPlugin' UGen allows you to use VST (2 and 3) audio plugins
 within the SuperCollider computermusic environment.
 .
 Features:
  - supports all VST2 and VST3 plugins (audio effect, MIDI effect,
    instruments, etc.)
  - automate plugin parameters (sample accurate for VST3 plugins)
  - arbitrary number of inputs/outputs + VST3 multi-bus support
  - use either the native VST GUI or a generic editor
  - preset management: read/write standard VST preset files or set/get the
    plugin state as raw data to build your own preset management
  - MIDI input/output
  - transport and tempo support (for arpeggiators, sequencers, parameters
    with musical time units, etc.)
  - offline rendering
  - search for plugins in the standard VST directories or in user defined
    paths
  - bit-bridging and sandboxing
  - (optional) multithreaded plugin processing

## pd-vstplugin 0.6.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

# minimum macOS deployment target; must come before project()!
if (APPLE)
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OSX deployment version")
endif()

project(vstplugin)
message(STATUS "---\n*** general ***")

include (CheckCXXCompilerFlag)

if(UNIX AND NOT APPLE AND NOT MINGW)
    set(LINUX TRUE)
endif()

# some MinGW setups don't define WIN32!
if (MINGW AND NOT WIN32)
    message(WARNING "Your MinGW setup doesn't define WIN32")
    set(WIN32 TRUE)
endif()

# build Wine host
if (LINUX)
    option(BUILD_WINE "Build Wine host(s)" OFF)
    if (BUILD_WINE)
        message(STATUS "Build Wine host")
        # set globally!
        set(CMAKE_C_COMPILER winegcc)
        set(CMAKE_CXX_COMPILER wineg++)
    endif()
endif()

if (MINGW)
    set(CMAKE_EXECUTABLE_SUFFIX ".exe")
endif()

# check for Clang or AppleClang
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_COMPILER_IS_CLANG 1)
endif()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
endif()
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

# check if the compiler can produce 32-bit binaries.
# For some reason we must move it up here...
if (APPLE)
    CHECK_CXX_COMPILER_FLAG(-m32 HAS_M32_SUPPORT)
endif()
if (LINUX)
    # CHECK_CXX_COMPILER_FLAG(-m32) fails with a linker error...
    # For now assume that -m32 is supported. LATER fix this.
    set(HAS_M32_SUPPORT 1)
endif()

# windres
if (WIN32 AND MINGW)
    # set windres.exe options
    # for some reason, CMake does not automatically take the correct windres.exe;
    # instead, it just grabs the first one it can find. For example, it might use a
    # 64-bit windres.exe while building with mingw32, which would lead to linker errors.
    # As a workaround, we explicitly pass the desired target architectre.
    if (CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(CMAKE_RC_FLAGS --target=pe-i386 ${CMAKE_RC_FLAGS})
    else()
        set(CMAKE_RC_FLAGS --target=pe-x86-64 ${CMAKE_RC_FLAGS})
    endif()
    # message(STATUS "CMAKE_RC_COMPILER: ${CMAKE_RC_COMPILER}")
    # message(STATUS "CMAKE_RC_FLAGS: ${CMAKE_RC_FLAGS}")

    # The solution above does not always work (e.g. when using a 32-bit windres.exe with mingw64),
    # so we need a feature test.
    if (NOT DEFINED HAVE_WINDRES)
        set(RC_TEST_OPTIONS -O coff ${CMAKE_RC_FLAGS} -i "${CMAKE_CURRENT_SOURCE_DIR}/sc/src/VSTPlugin.rc"
            -o "${CMAKE_CURRENT_BINARY_DIR}/rc_test.obj")
        execute_process(COMMAND "${CMAKE_RC_COMPILER}" ${RC_TEST_OPTIONS} RESULT_VARIABLE RC_TEST_RESULT)
        if (RC_TEST_RESULT EQUAL 0)
            set(HAVE_WINDRES 1 CACHE INTERNAL "RC compiler test")
            message(STATUS "windres.exe works!")
        else()
            set(HAVE_WINDRES 0 CACHE INTERNAL "RC compiler test")
            message(WARNING "Wrong windres.exe! Try to explicitly set CMAKE_RC_COMPILER.")
        endif()
    endif()
endif()

# Windows paths
if (WIN32)
    # check if "Program Files (x86)" exists (64-bit Windows) and if we compile for 32-bit
    set(_pf_x86 "ProgramFiles(x86)")
    if (DEFINED ENV{${_pf_x86}} AND (CMAKE_SIZEOF_VOID_P EQUAL 4))
        set(PROGRAMFILES $ENV{${_pf_x86}})
    else()
        set(PROGRAMFILES $ENV{PROGRAMFILES})
    endif()
    set(APPDATA $ENV{APPDATA})
    set(LOCALAPPDATA $ENV{LOCALAPPDATA})
endif()

# global compiler flags
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (MSVC)
    add_compile_options(/Zc:__cplusplus /fp:fast)
endif()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
    add_compile_options(-fvisibility=hidden)
    # disable some warnings
    add_compile_options(-Wno-unknown-pragmas -Wno-format-security)

    CHECK_CXX_COMPILER_FLAG(-msse HAS_CXX_SSE)
    if (HAS_CXX_SSE)
        add_compile_options(-msse)
    endif()

    CHECK_CXX_COMPILER_FLAG(-msse2 HAS_CXX_SSE2)
    if (HAS_CXX_SSE2)
        add_compile_options(-msse2)
    endif()

    CHECK_CXX_COMPILER_FLAG(-msse3 HAS_CXX_SSE3)
    if (HAS_CXX_SSE3)
        add_compile_options(-msse3)
    endif()

    # some people might still use old AMD CPUs...
    if (OFF)
        CHECK_CXX_COMPILER_FLAG(-msse4 HAS_CXX_SSE4)
        if (HAS_CXX_SSE4)
            add_compile_options(-msse4)
        endif()
    endif()

    CHECK_CXX_COMPILER_FLAG(-mfpmath=sse HAS_CXX_FPMATH_SSE)
    if (HAS_CXX_FPMATH_SSE)
        add_compile_options(-mfpmath=sse)
    endif()

    option(NATIVE "optimize for this machine (not portable!)" OFF)
    if (NATIVE)
        add_compile_options(-march=native)
    endif()

    add_compile_options(-ffast-math -funroll-loops -fomit-frame-pointer)
    add_compile_options(-Wstrict-aliasing)

    if (CMAKE_COMPILER_IS_CLANG)
        add_compile_options(-stdlib=libc++)
    endif()
endif()

if (MINGW)
    add_compile_options(-mstackrealign)
    # HACK: somehow --strip resp. install/strip target do not work on MSys2,
    # so we manually strip the symbols at link time - but only in Release mode.
    add_link_options($<$<CONFIG:RELEASE>:-s>)
endif()

# vst library
add_subdirectory(vst)

# vstplugin~
option(PD "build Pd external" ON)
if (PD)
    add_subdirectory(pd)
endif()

# VSTPlugin
option(SC "build SC plugin" ON)
if (SC)
    add_subdirectory(sc)
endif()

# test suite
option(TESTSUITE "build test suite" ON)
if (TESTSUITE)
    add_subdirectory(test)
endif()

=== pd/CMakeLists.txt ===
message(STATUS "---\n*** vstplugin~ ***")

# Pd directories:
if (NOT PD_DIR)
    if (WIN32)
        set(_pddir "${PROGRAMFILES}/Pd")
        if ((NOT PD_INCLUDEDIR OR NOT PD_BINDIR) AND NOT (EXISTS "${_pddir}"))
            set(PD_DIR "" CACHE PATH "Path to Pd application")
            message(FATAL_ERROR "Could not find Pd installation - please set PD_DIR")
        endif()
        set(PD_INCLUDEDIR "${_pddir}/src" CACHE PATH "Pd header files")
        set(PD_BINDIR "${_pddir}/bin" CACHE PATH "Pd executables")
    elseif(APPLE)
        file(GLOB _globresult "/Applications/Pd*.app")
        if (_globresult)
            list(GET _globresult 0 _pddir)
        endif()
        if (NOT PD_INCLUDEDIR AND NOT (EXISTS "${_pddir}"))
            set(PD_INCLUDEDIR "" CACHE PATH "Pd header files")
            message(FATAL_ERROR "Could not find Pd installation - please set PD_INCLUDEDIR")
        endif()
        set(PD_INCLUDEDIR "${_pddir}/Contents/Resources/src" CACHE PATH "Pd header files")
    else()
        set(PD_INCLUDEDIR "/usr/include/pd" CACHE PATH "Pd header files")
    endif()
else()
    set(PD_INCLUDEDIR "${PD_DIR}/src" CACHE PATH "Pd header files" FORCE)
    if (WIN32)
        set(PD_BINDIR "${PD_DIR}/bin" CACHE PATH "Pd binaries" FORCE)
    endif()
endif()

# install directory:
if (WIN32)
    set(PD_INSTALLDIR "${APPDATA}/Pd" CACHE PATH "Installation directoy")
elseif(APPLE)
    set(PD_INSTALLDIR "~/Library/Pd" CACHE PATH "Installation directory")
else()
    set(PD_INSTALLDIR "/usr/local/lib/pd-externals" CACHE PATH "Installation directory")
endif()
if (NOT PD_INSTALLDIR)
    # HACK: force relative path!
    set(PD_INSTALLDIR ".")
endif()
message(STATUS "PD_INSTALLDIR: ${PD_INSTALLDIR}")

# wine host installation
if (BUILD_WINE)
    # install wine hosts
    # NB: we cannot install it as a target because CMake would use the wrong
    # output name, so we need to use PROGRAMS with the full absolute file path.
    # NB: generator expressions are only supported for RENAME with CMake 3.20+,
    # so we use the OUTPUT_NAME property instead.
    get_target_property(hostname host OUTPUT_NAME)
    install(PROGRAMS "$<TARGET_FILE_DIR:host>/${hostname}.exe.so"
        RENAME "${hostname}"
        DESTINATION "${PD_INSTALLDIR}/vstplugin~")

    if (BUILD_HOST32)
        get_target_property(host32name host32 OUTPUT_NAME)
        install(PROGRAMS "$<TARGET_FILE_DIR:host32>/${host32name}.exe.so"
            RENAME ${host32name}
            DESTINATION "${PD_INSTALLDIR}/vstplugin~")
    endif()

    # don't actually build Pd external
    return()
endif()

message(STATUS "PD_INCLUDEDIR: ${PD_INCLUDEDIR}")
if (WIN32)
    message(STATUS "PD_BINDIR: ${PD_BINDIR}")
endif()

# the Pd external
add_library(pd MODULE "src/vstplugin~.h" "src/vstplugin~.cpp")

if (WIN32 AND HAVE_WINDRES)
    # resource file for sclang icon
    target_sources(pd PRIVATE "src/vstplugin~.rc")
endif()

target_include_directories(pd PRIVATE ${PD_INCLUDEDIR})

target_link_libraries(pd PRIVATE vst)

# multi-instance support
option(PD_MULTI_INSTANCE "Pd multi-instance support (for libpd)" OFF)
message(STATUS "Pd multi-instance support: ${PD_MULTI_INSTANCE}")
if (PD_MULTI_INSTANCE)
    target_compile_definitions(pd PUBLIC PDINSTANCE)
endif()

# plugin extension
set(PD_EXTENSION "" CACHE STRING "Pd plugin extension")
if (NOT PD_EXTENSION)
    # default extensions
    if (WIN32)
        set(SUFFIX ".dll")
    elseif(APPLE)
        set(SUFFIX ".pd_darwin")
    elseif(LINUX)
        set(SUFFIX ".pd_linux")
    else()
        set(SUFFIX "${CMAKE_SHARED_MODULE_SUFFIX}")
    endif()
else()
    set(SUFFIX ".${PD_EXTENSION}")
endif()
message(STATUS "Pd extension: ${SUFFIX}")

# output name
set_target_properties(pd PROPERTIES
    PREFIX "" # no prefix!
    OUTPUT_NAME "vstplugin~"
    SUFFIX ${SUFFIX})

# platform specific definitions and options
if (WIN32)
    if (MINGW)
        target_link_options(pd PRIVATE --enable-auto-import)
        target_link_libraries(pd PRIVATE "${PD_BINDIR}/pd.dll")
    else()
        target_link_libraries(pd PRIVATE "${PD_BINDIR}/pd.lib")
    endif()
elseif(APPLE)
    target_link_options(pd PRIVATE -undefined suppress -flat_namespace -bundle)
else()
    target_link_options(pd PRIVATE -rdynamic -fPIC)
endif()

# installation

install(TARGETS pd DESTINATION "${PD_INSTALLDIR}/vstplugin~")
if (MSVC)
    install(FILES $<TARGET_PDB_FILE:pd> OPTIONAL DESTINATION "${PD_INSTALLDIR}/vstplugin~")
endif()

if (TARGET host)
    add_dependencies(pd host)
    install(TARGETS host DESTINATION "${PD_INSTALLDIR}/vstplugin~")
    if (MSVC)
        install(FILES $<TARGET_PDB_FILE:host> OPTIONAL DESTINATION "${PD_INSTALLDIR}/vstplugin~")
    endif()
endif()

if (TARGET host32)
    add_dependencies(pd host32)
    install(TARGETS host32 DESTINATION "${PD_INSTALLDIR}/vstplugin~")
endif()

if (TARGET host_amd64)
    add_dependencies(pd host_amd64)
    install(TARGETS host_amd64 DESTINATION "${PD_INSTALLDIR}/vstplugin~")
endif()

if (WIN32)
    if (HOST32_PATH)
        install(PROGRAMS "${HOST32_PATH}" RENAME "host_i386.exe"
            DESTINATION "${PD_INSTALLDIR}/vstplugin~")
    endif()
    if (HOST_AMD64_PATH)
        install(PROGRAMS "${HOST_AMD64_PATH}" RENAME "host_amd64.exe"
            DESTINATION "${PD_INSTALLDIR}/vstplugin~")
    endif()
endif()

file(GLOB PD_PATCHES "*.pd")
install(FILES ${PD_PATCHES} "../README.md" "../LICENSE.txt"
    DESTINATION "${PD_INSTALLDIR}/vstplugin~")

=== test/CMakeLists.txt ===
message(STATUS "---\n*** tests ***")

if (BRIDGE)
    add_executable(shm_test "shm_test.cpp")
    target_link_libraries(shm_test vst)
    target_include_directories(shm_test PUBLIC "../deps")
endif()

add_executable(normalize_path "normalize_path.cpp")
target_link_libraries(normalize_path vst)

add_executable(hashtable_test "hashtable_test.cpp")
target_link_libraries(hashtable_test vst_public)

=== vst/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,21 @@
 set_property(CACHE LOG_LEVEL PROPERTY STRINGS "SILENT;ERROR;WARNING;INFO;DEBUG;VERBOSE")
 message(STATUS "Log level: ${LOG_LEVEL}")
 target_compile_definitions(vst_public INTERFACE LOG_LEVEL=LOG_LEVEL_${LOG_LEVEL})
+# warn about old LOGLEVEL variable and remove it from the cache
+if (DEFINED LOGLEVEL)
+    message(WARNING "The LOGLEVEL option has been removed, please use LOG_LEVEL instead. "
+            "Note that the log level is now provided as a string, e.g. 'INFO'")
+    unset(LOGLEVEL CACHE)
+endif()
+
+# settings
+if (LINUX)
+    option(USE_RTLD_DEEPBIND "Load plugin modules with RTLD_DEEPBIND flag" OFF)
+    if (USE_RTLD_DEEPBIND)
+        message(STATUS "Load plugin modules with RTLD_DEEPBIND flag.")
+    endif()
+    target_compile_definitions(vst_common INTERFACE USE_RTLD_DEEPBIND=$<BOOL:${USE_RTLD_DEEPBIND}>)
+endif()
 
 # Windows version
 if (WIN32)

=== debian/changelog ===
pd-vstplugin (0.6.2-1) unstable; urgency=medium

  * New upstream version 0.6.2
  * Drop obsolete 'Priority: optional' stanza.
  * Bump standards version to 4.7.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 01 Feb 2026 23:42:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: pd-vstplugin
 Section: sound
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
@@ -12,7 +11,7 @@
  libvst3sdk-dev,
  libx11-dev,
  supercollider-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://git.iem.at/pd/vstplugin
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2025 IOhannes m zmölnig <umlaeute@debian.org>

#enable hardening
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

pd64ext:=$(shell /usr/share/puredata/debian/dekencpu $(DEB_HOST_ARCH))


FLAVORS = single double
builddir=debian/build/flavor-

CONFIG = \
	-DVST2=ON -DVST2DIR=/usr/include \
	-DVST3=ON -DVST3DIR=/usr/include/vst3sdk \
	-DPD_INSTALLDIR=/usr/lib/pd/extra \
	-DSC_INSTALLDIR=/usr/share/SuperCollider/Extensions/ \
	-DSC_INCLUDEDIR=/usr/include/SuperCollider \
	$(empty)


## per flavor configure options
CONFIG_single = -DSC=ON  -DPD=ON
CONFIG_double = -DSC=OFF -DPD=ON -DPD_EXTENSION=linux-$(pd64ext)-64.so -DPD_FLOATSIZE=64

%:
	dh $@

override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS))
override_dh_auto_install: $(patsubst %,install_%,$(FLAVORS))
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/SuperCollider/plugins
	-mv $(CURDIR)/debian/tmp/usr/share/SuperCollider/Extensions/VSTPlugin/plugins $(CURDIR)/debian/tmp/usr/lib/SuperCollider/plugins/VSTPlugin

configure_%:
	mkdir -p $(builddir)$*
	dh_auto_configure --builddirectory=$(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))
build_%:
	dh_auto_build -a  --builddirectory=$(builddir)$*
install_%:
	dh_auto_install   --builddirectory=$(builddir)$*


DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|sc/HelpSource/Classes/[^/]*\.jpg|sc/HelpSource/Classes/noparams\.JPG|sc/icons/sc_cube\.ico
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Test-Command: pd -batch debian/tests/searchplugins.pd
Features:
 test-name=pd32-search-vst2,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst,
 pd-vstplugin,
 puredata-core,

Test-Command: pd -batch debian/tests/searchplugins.pd
Features:
 test-name=pd32-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst3,
 pd-vstplugin,
 puredata-core,

Test-Command: pd64 -batch debian/tests/searchplugins.pd
Features:
 test-name=pd64-search-vst2,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst,
 pd-vstplugin,
 puredata64-core,

Test-Command: pd64 -batch debian/tests/searchplugins.pd
Features:
 test-name=pd64-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst3,
 pd-vstplugin,
 puredata64-core,

Test-Command: debian/tests/scwrapper debian/tests/searchplugins.sc
Features:
 test-name=sc3-search-vst,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 jackd2,
 lsp-plugins-vst,
 procps,
 sc3-vstplugin,

Test-Command: debian/tests/scwrapper debian/tests/searchplugins.sc
Features:
 test-name=sc3-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 jackd2,
 lsp-plugins-vst3,
 procps,
 sc3-vstplugin,

=== debian/watch ===
Version: 5

Template: Gitlab
Dist: https://git.iem.at/pd/vstplugin
Uversion-Mangle: s/v//g
